Description

Whether the 3.x vertex editor is an improvement to the 2.x version, is perhaps a matter of taste. So, not to replace the 3.x vertex editor,

would it be possible to include the 2.x vertex editor again, so that the user could select his or her preferred editor in the QGIS settings?

With heavy digitizing, I find the 2.x version so, so, so much better and accurate to use, with fewer fatiguing mouse clicks, drag and drop,

and IMO no visually unplesant highlighting of node or segment under mouse cursor etc.

History

#1 - 2018-10-29 09:16 PM - Giovanni Manghi

- Category changed from Editing to Digitising

I can't say I don't agree. Please raise your concerns also in the developers mailing list, so to reach a wider audience.

#2 - 2018-10-31 04:01 AM - Rhenriques Henriques

I also agree with this suggestion. The new QGIS 3 editor is different from every draw application and a lot less predictable and controlable than version 2. 

Every single drawing program works with node grab, displace and release in position (as it was also in QGIS 2.x). That's one mouse click and drag. In

version 3 we have to Click, release, drag and click again. Perhaps is a question of getting used to it. However I still like the old fashion a lot more.

#3 - 2018-10-31 03:25 PM - andskog -

Just sent to the developers mailing list. In essence:

Main 2.18 vertex editor pros and cons as I see it:

+ The vertices on the active feature are always visible, which has two important advantages: 1) I can always see the vertex, so I know where I need to

point the mouse cursor to grab it. 2) When zooming and panning to other parts of the map to edit other sections, I keep track of which feature it is.

+ The visual appearance of the active feature is calm, with no flashing halo effects as I move the mouse cursor around and across it.

+ There are fewer ("complex") mouse operations (clicks, drawing rectangles) to add, move or delete a vertex.

- It has been replaced :(

And for the 3.4 vertex editor:

- As the active feature is always the one below the mouse cursor, the vertices of the feature I'm editing are only visible when they are directly below the

cursor. This has two disadvantages: 1) I have to point the mouse cursor at the feature to see where the vertices are on a feature with few bends, and then

relocate the cursor to the vertex I'm after. 2) I might lose track of the feature when I zoom and pan the map to go to other parts of the feature to edit.

- The dynamic highlighting effect applied to the features and vertex below the mouse cursor at any time is in my opinion visually disturbing, both in itself and

when moving the mouse cursor across it without the intention to edit it.

- As the highlighting symbol of the vertex below the mouse cursor has a larger diameter than the 2.x vertex symbols, it is more cumbersome and

unpredictable in result when adding a vertex on a segment where the vertices are close together.

- There are more ("complex") mouse operations to add, move or delete a vertex.
- There are some operation inconsistencies: 1) Adding a vertex, either single-click the cross appearing on the hovered segment, or double-click anywhere

else on the line. 2) To move a two-vertex segment, click the segment and move it. To move a selected multi-vertex segment, click one of the vertices and

move it.

- When intending to move a segment, I have to take care that I don't click the cross that appears in the middle of the segment when hovering it, as this will

create a new vertex rather than move the segment.

My conclusion: The ease of use and efficiency with the 2.x vertex editor outshines the vertex editors in any other GIS software I know, and the 3.x version is

in my opinion a bit strenuous and ergonomically fatiguing in comparison when doing heavy vertex editing work.

#4 - 2018-10-31 05:52 PM - Giovanni Manghi

andskog - wrote:

Just sent to the developers mailing list. In essence:

Main 2.18 vertex editor pros and cons as I see it:

+ The vertices on the active feature are always visible, which has two important advantages: 1) I can always see the vertex, so I know where I need

to point the mouse cursor to grab it. 2) When zooming and panning to other parts of the map to edit other sections, I keep track of which feature it is.

+ The visual appearance of the active feature is calm, with no flashing halo effects as I move the mouse cursor around and across it.

+ There are fewer ("complex") mouse operations (clicks, drawing rectangles) to add, move or delete a vertex.

- It has been replaced :(

And for the 3.4 vertex editor:

- As the active feature is always the one below the mouse cursor, the vertices of the feature I'm editing are only visible when they are directly below

the cursor. This has two disadvantages: 1) I have to point the mouse cursor at the feature to see where the vertices are on a feature with few bends,

and then relocate the cursor to the vertex I'm after. 2) I might lose track of the feature when I zoom and pan the map to go to other parts of the

feature to edit.

- The dynamic highlighting effect applied to the features and vertex below the mouse cursor at any time is in my opinion visually disturbing, both in

itself and when moving the mouse cursor across it without the intention to edit it.

- As the highlighting symbol of the vertex below the mouse cursor has a larger diameter than the 2.x vertex symbols, it is more cumbersome and

unpredictable in result when adding a vertex on a segment where the vertices are close together.

- There are more ("complex") mouse operations to add, move or delete a vertex.

- There are some operation inconsistencies: 1) Adding a vertex, either single-click the cross appearing on the hovered segment, or double-click

anywhere else on the line. 2) To move a two-vertex segment, click the segment and move it. To move a selected multi-vertex segment, click one of

the vertices and move it.

- When intending to move a segment, I have to take care that I don't click the cross that appears in the middle of the segment when hovering it, as

this will create a new vertex rather than move the segment.

My conclusion: The ease of use and efficiency with the 2.x vertex editor outshines the vertex editors in any other GIS software I know, and the 3.x

version is in my opinion a bit strenuous and ergonomically fatiguing in comparison when doing heavy vertex editing work.

I mostly agree anyway the proper place where to raise this very well described concerns is the developers mailing list.

#5 - 2018-11-14 12:47 PM - Bernhard Ströbl

@andskog

To my understanding most of your issues result from the change in editing dogma: In QGIS 2 it was 

    1. Choose a feature with left click => feature and its nodes are visualized

    2. choose the node to edit with left click

    3. do some edits, e.g. delete or move the node

In QGIS 3 this changed to 
    1. when the feature you want to edit is highlighted (halo effect) left click on the vertex to move it

The reasoning behind this was: overcome that "features need to be explicitly selected before editing of nodes is possible" 

https://github.com/qgis/QGIS-Enhancement-Proposals/issues/69

While the new dogma is a lot faster for the particular scenario of moving an exisiting vertex it poses problems for other scenarios:

    -  Delete a vertex: was: (choose feature) click on vertex and press Del, is now: select vertex either with mouse frame (be careful to not select others) or

shift + R and left click and press Del: complicated

    -  If features are very close to each other (topologically correct) it is difficult/almost impossible to choose a node of the not haloed feature (was difficult in

QGIS 2, too). To use the select tool to first select the feature and then switch to the node tool again in order to select the vertex seems to be not really

practical.

I would suggest a feature request to reintroduce that a feature has to be chosen with the node tool before it can be edited (i.e. make this feature the editable

feature) and to display this features' nodes. This is different from "select" in a way that only nodes of this feature can be edited during its "chosen" status

(topology is honoured, of course)

My suggestion would be: Left click on a feature's boundary to choose it and show its vertices (as was in 2.18), right click to instead choose an adjacent

feature if there is one. Currently a right click shows a context menu to open the vertex editor, this would have to be replaced by showing the vertex editor

once a feature is chosen (as was in 2.18). Halo effect only to visualize which feature will be chosen if user clicks at that moment. Probably: If with the

choosing click a vertex is clicked (was specially highlighted with halo before) this vertex is immediately selected and can be dropped at its new position

with another click.

#6 - 2018-11-14 06:10 PM - Giovanni Manghi

- Status changed from Open to Feedback

#7 - 2018-11-15 04:38 PM - andskog -

@Bernhard

Didn't know about the right-click functionality to get the vertices "permanently" marked, glad the feature is there.

I really think the 2.x vertex editor is brilliant, and would be glad to see it back as it was, but in case any modification of it would be reintroduced, I'd just

point out that I think the functionality should benefit heavy vertex editing rather than smaller editing tasks if any (beneficial with 2.x-ish AND 3.x option in

QGIS settings), meaning it should be as "eye-resting" and ergonimical as possible. In my view, e.g. "mousedown-drag-mouseup" to move a vertex is

ergonomically better (and quicker) than "mousedown-mouseup-cursor move-mousedown-mouseup".

#8 - 2018-11-16 09:04 AM - Bernhard Ströbl

andskog - wrote:

I really think the 2.x vertex editor is brilliant, and would be glad to see it back as it was, but in case any modification of it would be reintroduced, I'd

just point out that I think the functionality should benefit heavy vertex editing rather than smaller editing tasks if any (beneficial with 2.x-ish AND 3.x

option in QGIS settings), meaning it should be as "eye-resting" and ergonimical as possible. In my view, e.g. "mousedown-drag-mouseup" to move a

vertex is ergonomically better (and quicker) than "mousedown-mouseup-cursor move-mousedown-mouseup".

I think this is a question of personal taste (and what someone is used to), in CAD the click + click approach is very common (I know at least from

Microstation). The main reason AFAIK that the klick + press + release was dropped and changed to click + click is that thus the advanced editing panel

can be used.

#9 - 2018-11-16 12:38 PM - Burghardt Scholle

I think Bernhard's suggestion is a good one, since it combines the advantages of both philosophies and gives the user the greatest possible flexibility when

dealing with vertex editing. In particular, the selection of a vertex to be edited was difficult even under 2.x. The "right mouse button" option for switching to a
vertex located on another feature is a nice idea. It is important that the user can perform current tasks in connection with the vertex tool ergonomically and

clearly defined:

1. selection of the desired node/segment

2. setting a new node/segment

3. moving a node/segment

4. delete a node/segment

When setting a new vertex, there is (still) the difficulty that with very small distances between the vertices the red "cross" doesn't appears on the line for

creating a new vertex. In this case you have to move the mouse away from the line until the "cross" appears on the line. This mouse movement is very

"fiddly" and not clearly defined. It inhibits the flow of work.
